#include "pico/stdlib.h"
#include "notes.h"

#define MUSIC_TIME 1

const uint16_t duty_cycle = 1000; //music
typedef struct
{//music
  unsigned short frequency;
  short  duration;
} note_struct;

// timer declaration  First timer for note, second for spacing
typedef struct
{//music
  uint slice_num;
  note_struct *pt;
  uint delayOFF;
  uint wholenote;
  uint tempo;
  volatile uint Done;
} note_timer_struct;


//music
int64_t timer_note_callback(alarm_id_t id, void *user_data);

note_struct HappyBirday[]=
{//music
    { NOTE_C4,4 },
    { NOTE_C4,8 },
    { NOTE_D4,-4},
    { NOTE_C4,-4},
    { NOTE_F4,-4},
    { NOTE_E4,-2},
    { NOTE_C4,4},
    {NOTE_C4,8},
    {NOTE_D4,-4},
    {NOTE_C4,-4},
    {NOTE_G4,-4},
    {NOTE_F4,-2},
    {NOTE_C4,4},
    {NOTE_C4,8},
    {NOTE_C5,-4},
    {NOTE_A4,-4},
    {NOTE_F4,-4},
    {NOTE_E4,-4},
    {NOTE_D4,-4},
    {NOTE_AS4,4},
    {NOTE_AS4,8},
    {NOTE_A4,-4},
    {NOTE_F4,-4},
    {NOTE_G4,-4},
    {NOTE_F4,-2},
    {REST,0}};

note_struct HarryPotter[]=
{//music
 // Hedwig's theme fromn the Harry Potter Movies
  // Socre from https://musescore.com/user/3811306/scores/4906610

  { REST, 2}, { NOTE_D4, 4},{ NOTE_G4, -4}, { NOTE_AS4, 8}, { NOTE_A4, 4},
  { NOTE_G4, 2}, { NOTE_D5, 4},{ NOTE_C5, -2}, { NOTE_A4, -2},
  { NOTE_G4, -4}, { NOTE_AS4, 8}, { NOTE_A4, 4},
  { NOTE_F4, 2}, { NOTE_GS4, 4},
  { NOTE_D4, -1}, { NOTE_D4, 4},

  { NOTE_G4, -4}, { NOTE_AS4, 8}, { NOTE_A4, 4},
  { NOTE_G4, 2}, { NOTE_D5, 4},
  { NOTE_F5, 2}, { NOTE_E5, 4},
  { NOTE_DS5, 2}, { NOTE_B4, 4},
  { NOTE_DS5, -4}, { NOTE_D5, 8}, { NOTE_CS5, 4},
  { NOTE_CS4, 2}, { NOTE_B4, 4},
  { NOTE_G4, -1},
  { NOTE_AS4, 4},

  { NOTE_D5, 2}, { NOTE_AS4, 4},
  { NOTE_D5, 2}, { NOTE_AS4, 4},
  { NOTE_DS5, 2}, { NOTE_D5, 4},
  { NOTE_CS5, 2}, { NOTE_A4, 4},
  { NOTE_AS4, -4}, { NOTE_D5, 8}, { NOTE_CS5, 4},
  { NOTE_CS4, 2}, { NOTE_D4, 4},
  { NOTE_D5, -1},
  {REST,4}, { NOTE_AS4,4},

  { NOTE_D5, 2}, { NOTE_AS4, 4},
  { NOTE_D5, 2}, { NOTE_AS4, 4},
  { NOTE_F5, 2}, { NOTE_E5, 4},
  { NOTE_DS5, 2}, { NOTE_B4, 4},
  { NOTE_DS5, -4}, { NOTE_D5, 8}, { NOTE_CS5, 4},
  { NOTE_CS4, 2}, { NOTE_AS4, 4},
  { NOTE_G4, -1}};

note_struct All_Music[]=
{
    {NOTE_B0  ,MUSIC_TIME},
    {NOTE_C1  ,MUSIC_TIME}, 
    {NOTE_CS1 ,MUSIC_TIME},
    {NOTE_D1  ,MUSIC_TIME},
    {NOTE_DS1 ,MUSIC_TIME},
    {NOTE_E1  ,MUSIC_TIME},
    {NOTE_F1  ,MUSIC_TIME},
    {NOTE_FS1 ,MUSIC_TIME},
    {NOTE_G1  ,MUSIC_TIME},
    {NOTE_GS1 ,MUSIC_TIME},
    {NOTE_A1  ,MUSIC_TIME},
    {NOTE_AS1 ,MUSIC_TIME},
    {NOTE_B1  ,MUSIC_TIME},
    {NOTE_C2  ,MUSIC_TIME},
    {NOTE_CS2 ,MUSIC_TIME},
    {NOTE_D2  ,MUSIC_TIME},
    {NOTE_DS2 ,MUSIC_TIME},
    {NOTE_E2  ,MUSIC_TIME},
    {NOTE_F2  ,MUSIC_TIME},
    {NOTE_FS2 ,MUSIC_TIME},
    {NOTE_G2  ,MUSIC_TIME},
    {NOTE_GS2 ,MUSIC_TIME},
    {NOTE_A2  ,MUSIC_TIME},
    {NOTE_AS2 ,MUSIC_TIME},
    {NOTE_B2  ,MUSIC_TIME},
    {NOTE_C3  ,MUSIC_TIME},
    {NOTE_CS3 ,MUSIC_TIME},
    {NOTE_D3  ,MUSIC_TIME},
    {NOTE_DS3 ,MUSIC_TIME},
    {NOTE_E3  ,MUSIC_TIME},
    {NOTE_F3  ,MUSIC_TIME},
    {NOTE_FS3 ,MUSIC_TIME},
    {NOTE_G3  ,MUSIC_TIME},
    {NOTE_GS3 ,MUSIC_TIME},
    {NOTE_A3  ,MUSIC_TIME},
    {NOTE_AS3 ,MUSIC_TIME},
    {NOTE_B3  ,MUSIC_TIME},
    {NOTE_C4  ,MUSIC_TIME},
    {NOTE_CS4 ,MUSIC_TIME},
    {NOTE_D4  ,MUSIC_TIME},
    {NOTE_DS4 ,MUSIC_TIME},
    {NOTE_E4  ,MUSIC_TIME},
    {NOTE_F4  ,MUSIC_TIME},
    {NOTE_FS4 ,MUSIC_TIME},
    {NOTE_G4  ,MUSIC_TIME},
    {NOTE_GS4 ,MUSIC_TIME},
    {NOTE_A4  ,MUSIC_TIME},
    {NOTE_AS4 ,MUSIC_TIME},
    {NOTE_B4  ,MUSIC_TIME},
    {NOTE_C5  ,MUSIC_TIME},
    {NOTE_CS5 ,MUSIC_TIME},
    {NOTE_D5  ,MUSIC_TIME},
    {NOTE_DS5 ,MUSIC_TIME},
    {NOTE_E5  ,MUSIC_TIME},
    {NOTE_F5  ,MUSIC_TIME},
    {NOTE_FS5 ,MUSIC_TIME},
    {NOTE_G5  ,MUSIC_TIME},
    {NOTE_GS5 ,MUSIC_TIME},
    {NOTE_A5  ,MUSIC_TIME},
    {NOTE_AS5 ,MUSIC_TIME},
    {NOTE_B5  ,MUSIC_TIME},
    {NOTE_C6  ,MUSIC_TIME},
    {NOTE_CS6 ,MUSIC_TIME},
    {NOTE_D6  ,MUSIC_TIME},
    {NOTE_DS6 ,MUSIC_TIME},
    {NOTE_E6  ,MUSIC_TIME},
    {NOTE_F6  ,MUSIC_TIME},
    {NOTE_FS6 ,MUSIC_TIME},
    {NOTE_G6  ,MUSIC_TIME},
    {NOTE_GS6 ,MUSIC_TIME},
    {NOTE_A6  ,MUSIC_TIME},
    {NOTE_AS6 ,MUSIC_TIME},
    {NOTE_B6  ,MUSIC_TIME},
    {NOTE_C7  ,MUSIC_TIME},
    {NOTE_CS7 ,MUSIC_TIME},
    {NOTE_D7  ,MUSIC_TIME},
    {NOTE_DS7 ,MUSIC_TIME},
    {NOTE_E7  ,MUSIC_TIME},
    {NOTE_F7  ,MUSIC_TIME},
    {NOTE_FS7 ,MUSIC_TIME},
    {NOTE_G7  ,MUSIC_TIME},
    {NOTE_GS7 ,MUSIC_TIME},
    {NOTE_A7  ,MUSIC_TIME},
    {NOTE_AS7 ,MUSIC_TIME},
    {NOTE_B7  ,MUSIC_TIME},
    {NOTE_C8  ,MUSIC_TIME},
    {NOTE_CS8 ,MUSIC_TIME},
    {NOTE_D8  ,MUSIC_TIME},
    {NOTE_DS8 ,MUSIC_TIME},
    {REST     ,MUSIC_TIME},
};

note_struct Power_On_Prompt[]=
{
    //{NOTE_CS7 ,MUSIC_TIME},
    //{NOTE_D7  ,MUSIC_TIME},
    
    {NOTE_DS7 ,-16},
    {NOTE_E7  ,-16},
    {NOTE_F7  ,-16},
    
   
    //{NOTE_FS7 ,MUSIC_TIME},
    //{NOTE_G7  ,MUSIC_TIME},
    //{NOTE_GS7 ,MUSIC_TIME},
    //{NOTE_A7  ,MUSIC_TIME},
    //{NOTE_AS7 ,MUSIC_TIME},
};

note_struct TEST[]=
{
  {270,-200},
  {2290,-200},
  {3010,-200},
};

int64_t timer_note_callback(alarm_id_t id, void *user_data);

note_timer_struct noteTimer;

static inline void pwm_calcDivTop(pwm_config *c,int frequency,int sysClock)
{//music
  uint  count = sysClock * 16 / frequency;
  uint  div =  count / 60000;  // to be lower than 65535*15/16 (rounding error)
  if(div < 16)
      div=16;
  c->div = div;
  c->top = count / div;
}

uint playTone(note_timer_struct *ntTimer)
{//music
  int duration;
  pwm_config cfg = pwm_get_default_config();

  note_struct * note = ntTimer->pt;
  duration = note->duration;
  if(duration == 0) return 0;
  if(duration>0)
      duration = ntTimer->wholenote / duration;
  else
      duration = ( 3 * ntTimer->wholenote / (-duration))/2;

  if(note->frequency == 0)
      pwm_set_chan_level(ntTimer->slice_num,PWM_CHAN_A,0);
  else
  {
   pwm_calcDivTop(&cfg,note->frequency,125000000);
   pwm_init(ntTimer->slice_num,&cfg,true);
   pwm_set_chan_level(ntTimer->slice_num,PWM_CHAN_A,cfg.top / 2);
  }
  ntTimer->delayOFF = duration;
  return duration;
}

int64_t timer_note_callback(alarm_id_t id, void *user_data)
{//music
  note_timer_struct *ntTimer = (note_timer_struct *) user_data;
  note_struct * note = ntTimer->pt;
  if(note->duration == 0)
     {
      ntTimer->Done=true;
      return 0;  // done!
     }
  // are we in pause time between  note
  if(ntTimer->delayOFF==0)
    {
       uint delayON = playTone(ntTimer);
       if(delayON == 0)
        {
           ntTimer->Done=true;
           return 0;
        }
       ntTimer->delayOFF = delayON;
       return 900*delayON;
    }
    else
    {
       pwm_set_chan_level(ntTimer->slice_num,PWM_CHAN_A,0);
       uint delayOFF = ntTimer->delayOFF;
       ntTimer->delayOFF=0;
       //  next note
       (ntTimer->pt)++;
       return 100*delayOFF;
    }
}

int play_melody(note_timer_struct *ntTimer, note_struct * melody, int tempo)
{//music
      ntTimer->Done = false;
      ntTimer->pt = melody;
      // set tempo
      ntTimer->tempo= tempo;
      ntTimer->wholenote = (60000 * 4) / tempo;//源数据
      ntTimer->delayOFF = 0;
      // start timer
      return add_alarm_in_us(1000,timer_note_callback,ntTimer,false);
}

